/*!
 * @mv-form-create/component-elm-tree v3.1.26
 * (c) 2018-2023 hxianyun
 * Github https://github.com/hxianyun/form-create with tree
 * Released under the MIT License.
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('vue'), require('@mv-form-create/utils/lib/toarray')) :
    typeof define === 'function' && define.amd ? define(['exports', 'vue', '@mv-form-create/utils/lib/toarray'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.FcTree = {}, global.Vue, global.toArray));
})(this, (function (exports, vue, toArray) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var toArray__default = /*#__PURE__*/_interopDefaultLegacy(toArray);

    const NAME = 'fcTree';
    var Tree = vue.defineComponent({
      name: NAME,
      inheritAttrs: false,
      formCreateParser: {
        mergeProp(ctx) {
          const props = ctx.prop.props;
          if (!props.nodeKey) props.nodeKey = 'id';
          if (!props.props) props.props = {
            label: 'title'
          };
        }
      },
      props: {
        type: String,
        modelValue: {
          type: [Array, String, Number],
          default: () => []
        }
      },
      emits: ['update:modelValue'],
      watch: {
        modelValue() {
          this.setValue();
        }
      },
      methods: {
        updateValue() {
          if (!this.$refs.tree) return;
          let value;
          if (this.type === 'selected') {
            value = this.$refs.tree.getCurrentKey();
          } else {
            value = this.$refs.tree.getCheckedKeys();
          }
          this.$emit('update:modelValue', value);
        },
        setValue() {
          if (!this.$refs.tree) return;
          const type = this.type;
          if (type === 'selected') {
            this.$refs.tree.setCurrentKey(this.modelValue);
          } else {
            this.$refs.tree.setCheckedKeys(toArray__default["default"](this.modelValue));
          }
        }
      },
      render() {
        return vue.createVNode(vue.resolveComponent("ElTree"), vue.mergeProps(this.$attrs, {
          "ref": "tree",
          "onCheck": this.updateValue,
          "onNode-click": this.updateValue
        }), this.$slots);
      },
      mounted() {
        this.setValue();
      }
    });

    exports["default"] = Tree;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
